# This script exports the current selected geometry (nodes + triangles)
# It also writes a json file which stores correspondances between obj vertices and piper nodes id
# for further update with updateNodesFromObj.py script
# 
# arguments:
#  /path/to/mesh.obj

# author: Thomas Lemaire date: 2017

import sys
import json

import piper.hbm
import piper.app

def writeObj(fem, nodeIds, elem2DIds, objFilePath):
    # gather node ids from nodes and elements
    allNodeIds = set()
    for id in nodeIds:
        allNodeIds.add(id)
    for elemId in elem2DIds:
        elem = fem.getElement2D(elemId)
        if not elem.getType() in {piper.hbm.ELT_TRI, piper.hbm.ELT_QUAD}:
            piper.app.logWarning("Unsupported: elem: {0} type: {1}".format(elemId, elem.getType()))
            continue
        ids = elem.get()
        for id in ids:
            allNodeIds.add(id)
    # in an obj file, vertices are referenced by their index, starting at 1, to describe faces
    nodeIdToObjIndex = dict()
    objIndexToNodeId = dict()
    with open(objFilePath, 'w') as objFile:
        piper.app.logInfo("Writting obj file {0} ...".format(objFilePath))
        objFile.write("# File generated by the PIPER application\n")
        currentIndex = 1 # obj convention starts at 1
        for nodeId in allNodeIds:
            nodeIdToObjIndex[nodeId] = currentIndex
            objIndexToNodeId[currentIndex] = nodeId
            coord = fem.getNode(nodeId).get().flatten()
            objFile.write("v {0} {1} {2}\n".format(coord[0], coord[1], coord[2]))
            currentIndex+=1
        for elemId in elem2DIds:
            elem = fem.getElement2D(elemId)
            ids = elem.get()
            if elem.getType() == piper.hbm.ELT_QUAD:
                idsQuad = elem.get()
                objFile.write("f {0} {1} {2}\n".format(nodeIdToObjIndex[idsQuad[0]], nodeIdToObjIndex[idsQuad[1]], nodeIdToObjIndex[idsQuad[2]]))
                objFile.write("f {0} {1} {2}\n".format(nodeIdToObjIndex[idsQuad[0]], nodeIdToObjIndex[idsQuad[2]], nodeIdToObjIndex[idsQuad[3]]))
                continue
            elif elem.getType() == piper.hbm.ELT_TRI:
                objFile.write("f {0} {1} {2}\n".format(nodeIdToObjIndex[ids[0]], nodeIdToObjIndex[ids[1]], nodeIdToObjIndex[ids[2]]))
            else:
                continue
    objIdFilePath = objFilePath+".json"
    with open(objIdFilePath, 'w') as objIdFile:
        piper.app.logInfo("Writting obj id file {0} ...".format(objIdFilePath))
        json.dump(objIndexToNodeId, objIdFile)

model = piper.app.Context.instance().project().model()

# if the model is empty, we can do nothing
if model.empty():
    piper.app.logWarning("Model is empty")
elif 2 != len(sys.argv) :
    raise RuntimeError("Invalid arguments")
else :
    modelVTK = model.fem().getFEModelVTK()
    nodeIds = modelVTK.getSelectedNodes()
    elem2DIds = modelVTK.getSelectedElements(2)
    piper.app.logInfo("nb selected nodes: {0}".format(len(nodeIds)))
    piper.app.logInfo("nb selected elements: {0}".format(len(elem2DIds)))
    writeObj(model.fem(), nodeIds, elem2DIds, sys.argv[1])
    
    
